[tox]
envlist = py37,py38,py39,py310,lint

[testenv]
pip_pre = False
deps =
    idna
    -rdev-requirements.txt
commands =
    py.test {posargs:--cov rfc3986 --cov-fail-under 100 tests/}

[testenv:pypy]
deps = {[testenv]deps}
commands = py.test {posargs}

[testenv:pre-commit]
basepython = python3
skip_install = true
deps = pre-commit
commands =
    pre-commit run --all-files --show-diff-on-failure

[testenv:lint]
basepython = python3
skip_install = true
deps =
    {[testenv:flake8]deps}
    black
commands =
    black -l 78 {env:BLACK_ARGS:} -t py37 src/rfc3986 tests/
    {[testenv:flake8]commands}

[testenv:flake8]
basepython = python3
skip_install = true
deps =
    flake8
    flake8-docstrings
    flake8-import-order
commands = flake8 {posargs} src/rfc3986

[testenv:venv]
commands = {posargs}

[testenv:build]
deps =
    wheel
commands =
    python setup.py sdist bdist_wheel

[testenv:release]
deps =
    {[testenv:build]deps}
    twine>=1.4.0
commands =
    {[testenv:build]commands}
    twine upload {posargs:--skip-existing dist/*}

[testenv:docs]
basepython = python3
deps =
    -rdocs/source/requirements.txt
commands =
    sphinx-build -WE -c docs/source/ -b html docs/source/ docs/build/html
    sphinx-build -WE -c docs/source/ -b doctest docs/source/ docs/build/html

[testenv:readme]
deps =
    readme
commands =
    python setup.py check -r -s

[pytest]
addopts = -q
norecursedirs = *.egg .git .* _*

[flake8]
extend-ignore = D203, W503, E203
exclude =
    .tox,
    .git,
    __pycache__,
    *.pyc,
    *.egg-info,
    .cache,
    .eggs
max-complexity = 10
import-order-style = google
